VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "PicWin"
   ClientHeight    =   4980
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6975
   DrawStyle       =   6  'Inside Solid
   FillColor       =   &H00FFFFFF&
   ForeColor       =   &H00000000&
   LinkTopic       =   "Form1"
   ScaleHeight     =   4980
   ScaleWidth      =   6975
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame Frame1 
      BackColor       =   &H00C0C0C0&
      Caption         =   "FMH Electronics"
      Height          =   1095
      Left            =   1800
      TabIndex        =   3
      Top             =   2400
      Width           =   4215
      Begin VB.Label Label3 
         Caption         =   "bitcraft@global.co.za"
         Height          =   255
         Left            =   1200
         TabIndex        =   6
         Top             =   720
         Width           =   1815
      End
      Begin VB.Label Label1 
         Caption         =   "Tools for microcontroller software development V6.3"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   360
         Width           =   3855
      End
   End
   Begin VB.CommandButton cmdTREND3 
      Caption         =   "PicWin"
      Height          =   375
      Left            =   1800
      TabIndex        =   2
      Top             =   3720
      Width           =   1095
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Fuzzy"
      Height          =   375
      Left            =   1800
      TabIndex        =   1
      Top             =   4200
      Width           =   1095
   End
   Begin VB.CommandButton cmdSstop 
      Caption         =   "Exit"
      Height          =   375
      Left            =   5040
      TabIndex        =   0
      Top             =   3720
      Width           =   972
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   1440
      Top             =   840
   End
   Begin VB.Label Label2 
      Caption         =   "Under development"
      Height          =   375
      Left            =   2925
      TabIndex        =   5
      Top             =   4290
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1                             ' Set array subscripts start at 1.
Private LoadFlag As Boolean     ' To init Rule base at start-up
Private Sub cmdSstop_Click()
     End
End Sub
Private Sub cmdTREND3_Click()
    Form1.Hide                              ' Hide main Screen
    frmTREND3.Show 0                ' Show PICWin screen
End Sub
Private Sub Command3_Click()
    Form2.Show                          ' Show Fuzzy form
End Sub
Private Sub Form_Load()
Dim iCount As Integer
 If LoadFlag = False Then           ' Initialise Rule data base at startup
        For iCount = 0 To 299
            RuleBase(iCount) = -1
        Next iCount
        LoadFlag = True
End If

    X_Gain(1) = 1
    X_Gain(2) = 1
    X_Gain(3) = 1
    X_Gain(4) = 1
    X_Gain(5) = 1
    X_Gain(6) = 1
    
    Alpha = 400                             ' Init Time Scroll value
End Sub
Private Sub Timer1_Timer()
'############################################################
'# Received data handler and Communication Initiator
'# This Timer routine will first check if there is data received from PIC from the
'# previous scan. The received data is then shifted into the array for the appropriate
'# trace. The next PIC data scan is then initiated by transmitting the data request
'# for the first active trace (The data requests for the rest of the active traces are
'# then done by the communication interrupt (event) handler).
'# Note that for non-active traces, or those for which no reply was received
'# the input data is set to 0.
'#
'# Note: The Interval property of this timer can be adjusted
'#          by the user at run-time to increase and decrease
'#          the data scan rate.

    Dim i As Integer
    Static ScanCount As Integer             ' Scan cycle counter
    Static ScanTotal As Single               ' Scantime accumulator
    
    ' There are 20 X-intervals on the trend screen. The following code
    ' calculates the time-duration for an X-interval, and also the rate of
    ' scanning the PIC over an average of 20 scans
    ScanCount = ScanCount + 1
    ScanTotal = ScanTotal + (timeGetTime - TimeCount2)  ' Add time of previous cycle
    If ScanCount >= 20 Then
            ScanSpeed = ScanTotal / 1000                             ' Calc time for 1 X-interval...in Seconds
            ScanRate = ScanTotal / 20                                   ' Calc rate using average over 20 scans
            ScanCount = 0
            ScanTotal = 0
    End If
    
    
   DispScanData
   ' Display received data (from previous scan) for the active scan data channels.
   
   frmTREND3.Label33(CommandIndex) = FBackValue
   ' Display received command feedback value
    
    ' Shift new data into trend arrays
   RotateArray arrTREND1(), DataValue(1)
   RotateArray arrTREND2(), DataValue(2)
   RotateArray arrTREND3(), DataValue(3)
   RotateArray arrTREND4(), DataValue(4)
   RotateArray arrTREND5(), DataValue(5)
   RotateArray arrTREND6(), DataValue(6)
   
    If Not ScanBusy Then                                ' Test if scan was completed
            ScanToShort = False: CommsFail = False
    Else
            If PICReplied Then
                    ScanToShort = True
                    frmTREND3.Label25.Visible = True
            Else
                    CommsFail = True
                    For i = 1 To 6
                        If frmTREND3.chkScan(i).Value = Checked Then
                            frmTREND3.Label28.Visible = True
                        End If
                    Next i
            End If
    End If
    
    If Not ScanToShort Then
                ScanBusy = True: PICReplied = False
                If FeedBackReq Then
                            FeedBackReqActive = True
                            TxDataRequest FBackAddr, FBackDataType
                Else
                            FeedBackReqActive = False
                            ScanInitiator
                            ' Find 1st active trace and Tx its data-request message. The data request
                            ' for the other active traces will be done by the comms handler.(continuator)
                End If
    End If
    
 TimeCount2 = timeGetTime
    ' Code to shift the snapshot marker in synch
    ' with the scan cycle
 If Current_X > 0 Then
      Current_X = Current_X - 1
                If Not FreezeFlag Then
                    frmTREND3.lblIndex.Caption = Current_X + Alpha - 800     ' Display current index
                End If
 Else
        If Not FreezeFlag Then
            frmTREND3.linMarker.Visible = False             ' Hide snapshot line if it moved off-screen
            frmTREND3.lblIndex.Visible = False               ' Hide Index value because no marker line
        End If
 End If
End Sub

Public Sub DispScanData()
    ' Display received data for the active scan data channels.
    ' If a chanell is active but its WarchDog flag is set then display Comms Fail
    ' For the inactive channels display "Scan OFF"
    Dim i As Integer
    For i = 1 To 6
        If DataWatchDog(i) Then                                                ' Test if data received
            DataValue(i) = 0                                                        ' Data = 0 if comms fail or inactive
            ByteBits(i) = 0
            If frmTREND3.chkScan(i).Value = Checked Then      ' Test if scan active
                frmTREND3.lblAddress(i).Caption = "Comms Fail"
            Else
                frmTREND3.lblAddress(i).Caption = "Scn OFF "     ' Blank if channel inactive
            End If
        Else
            If DataType(i) = 1 Then
                frmTREND3.lblAddress(i).Caption = BinC(ByteBits(i))     ' Display received value as binary bits
            Else
                frmTREND3.lblAddress(i).Caption = DataValue(i)            ' Display received value as number
            End If
        End If
        DataWatchDog(i) = True                                                         ' Will be set to FALSE by comms handler
                                                                                                        ' when message received
    Next i
    

End Sub

Public Sub ScanInitiator()
    ' Find 1st active trace and Tx its data-request message. The data request
    ' for the other active traces will be done by the comms handler.(continuator)
    Dim i As Integer
    Dim PIC_Data As String
    Dim AddressPIC As Integer

    For i = 1 To 6
            If frmTREND3.chkScan(i).Value = Checked Then
                ScanBusy = True                                      ' Indicate that we are scanning PIC
                RxChannel = i                                           ' Set active channel
                PIC_Data = frmTREND3.MSComm1.Input    ' Clear Rx buffer with a dummy read
                
                ' Tx data request: FF, NOB, FCODE, ADDRESS
                            ' First adjust PIC target address if requesting Word data
                            If DataType(i) = 3 Then
                                AddressPIC = PicAddress(i) + 1  ' Point to LSB address for Word data
                            Else
                                AddressPIC = PicAddress(i)
                            End If
                                 ' Now transmit the request message to PIC with a delay
                                ' between bytes. The delay is adjustable on-line for those
                                ' situations where the PIC is very busy and cannot handle
                                ' bytes so fast.
                                TxByte (255)            ' Tx Message Start Byte
                                TxByte (2)               ' Tx NOB in message
                                    
                            If ReadBank2(i) Then
                                TxByte (3 + 128)        ' Tx FCODE byte
                            Else
                                TxByte (3)                 ' Tx FCODE byte
                            End If
                            
                                TxByte (AddressPIC And &HFF)   ' Tx Address byte
                Exit For
            End If
    Next i

End Sub
